import lejos.nxt.*;
import lejos.nxt.comm.*;
import java.io.*;

public class XorInOut extends Thread implements ButtonListener {

	BTConnection btc = null;

	DataInputStream dis = null;
	DataOutputStream dos = null;

	boolean running = true;

	public XorInOut() {

		String connected = "Connected";
		String waiting = "Waiting";

		LCD.drawString(waiting, 0, 0);
		LCD.refresh();

		btc = Bluetooth.waitForConnection();

		LCD.clear();
		LCD.drawString(connected, 0, 0);
		LCD.refresh();

		try {
			InputStream is = btc.openInputStream();
			OutputStream os = btc.openOutputStream();
			dis = new DataInputStream(is);
			dos = new DataOutputStream(os);
		} catch (IOException e) {
		}

		Button.LEFT.addButtonListener(this);
		Button.RIGHT.addButtonListener(this);
		Button.ESCAPE.addButtonListener(this);
		Button.ENTER.addButtonListener(this);

	}

	public void buttonPressed(Button btn) {
		int sensorIn = -1;
		if (btn == Button.LEFT)
			sensorIn = 2;
		else if (btn == Button.RIGHT)
			sensorIn = 1;
		else if (btn == Button.ENTER)
			sensorIn = 3;
		else {
			sensorIn = 9;
		}
		if (sensorIn != -1) {
			try {
				dos.writeInt(sensorIn);
				dos.flush();
			} catch (IOException e) {
			}
			if (sensorIn == 9)
				suicide();
		}
	}

	public void buttonReleased(Button btn) {
		int sensorIn = 0;
		if (btn == Button.ENTER) {
			try {
				dos.writeInt(sensorIn);
				dos.flush();
			} catch (IOException e) {
			}
		}

	}

	public void run() {
		while (running) {
			try {
				int actuatorOut = dis.readInt();
				LCD.clear();
				LCD.drawString("net out:", 0, 0);
				LCD.drawInt(actuatorOut, 1, 1);
				LCD.refresh();
			} catch (IOException ioe) {
			}
		}

	}

	public void suicide() {

		try {
			dis.close();
			dos.close();
			btc.close();
		} catch (IOException e) {
		}

		LCD.clear();

		running = false;

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		XorInOut xsa = new XorInOut();
		xsa.start();
	}

}
